//+------------------------------------------------------------------+
//|                                                     Y_ZZ_Ind.mq4 |
//+------------------------------------------------------------------+
 
#property indicator_chart_window

extern string    ZigZag = "------ ZigZag  ---------";
extern  int      Depth            =      12; // Depth
extern  int      Deviation        =       5; // Deviation
extern  int      Backstep         =       3; // Backstep
extern string    Limits = "------ DistanseLimits  ---------";
extern  int      DistanseLimits_1_2_min = 2;
extern  int      DistanseLimits_1_2_max = 500;
extern  int      DistanseLimits_2_3_min = 2;
extern  int      DistanseLimits_2_3_max = 500;
extern string    Colors  = " ---- COLORS -----";
extern color     Short        = DodgerBlue;      //    
extern color     Long         = Gold; //    

//-------
string nms,nmb; int mp;
//---------------------------------------------------------------------------
void DeleteObjects(string text)
  {
   string name;
   for(int i=ObjectsTotal()-1; i>=0; i--)
     {
      name=ObjectName(i);
      if(StringFind(name,text)>-1) ObjectDelete(name);
     }
  }  
//-------------------------------------------------------------------
int init()
{  mp=1; if(Digits==3 || Digits==5)mp=10;
   DistanseLimits_1_2_min *=mp;DistanseLimits_1_2_max *=mp;
   DistanseLimits_2_3_min *=mp;DistanseLimits_2_3_max *=mp;
   nms="s_zz_"+Symbol();
   nmb="b_zz_"+Symbol();
   return(0);
}
//-------------------------------------------------------------------- 
int deinit()
{
  DeleteObjects("zz"); 
  return (0);
}
//-------------------------------------------------------------------- 
int start()
{
  DeleteObjects("zz");
  int bars=Bars;//WindowBarsPerChart(); 
  int nzz=0;
  for(int k=1; k<=bars; k++)
     {
      double zz=0;
      zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,k);
      if(zz>0){
         if(nzz==0){Pattern0(k);nzz++;}
         else Pattern(k);
         }
     } 
   return(0);
}
//--------------------------------------------------------
double ND(double x){return(NormalizeDouble(x,Digits));}
//--------------------------------------------------------
void Pattern(int shift){
double zz=0,ZZ0=0,ZZ1=0,ZZ2=0,ZZ3=0,ZZ4=0; int cnt=0; 
int T0=0,T1=0,T2=0,T3=0,T4=0;
int bars=iBars(NULL,0);
for(int i=shift; i<Bars; i++){
    zz=0;
    zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,i);
    if(zz!=0 && cnt==0){ZZ0=zz; T0=Time[i]; cnt=1;continue;}
    if(cnt==1)if(zz!=0 && zz!=ZZ0){ZZ1=zz; T1=Time[i];  cnt=2; continue;}
    if(cnt==2)if(zz!=0 && zz!=ZZ1){ZZ2=zz; T2=Time[i];  cnt=3; continue;}
    if(cnt==3)if(zz!=0 && zz!=ZZ2){ZZ3=zz; T3=Time[i];  cnt=4; break;}
   }
   if(ZZ0<ZZ1 && ZZ0<ZZ2){// DN
      if(ZZ1>ZZ2 && ZZ3>ZZ1)
      {
      if(ZZ1-ZZ2>=DistanseLimits_1_2_min*Point && ZZ1-ZZ2<=DistanseLimits_1_2_max*Point)
      if(ZZ3-ZZ2>=DistanseLimits_2_3_min*Point && ZZ3-ZZ2<=DistanseLimits_2_3_max*Point)
       {SetLine(nms+shift,ZZ2,T2,ZZ1,T1,Short,0,3);
        SetFibo("fb"+nms+shift,ZZ2,T2,ZZ1,T1,Short,0,0);}
      }
      }
   if(ZZ0>ZZ1 && ZZ0>ZZ2){// UP
      if(ZZ1<ZZ2 && ZZ3<ZZ1)
      {
      if(ZZ2-ZZ1>=DistanseLimits_1_2_min*Point && ZZ2-ZZ1<=DistanseLimits_1_2_max*Point)
      if(ZZ2-ZZ3>=DistanseLimits_2_3_min*Point && ZZ2-ZZ3<=DistanseLimits_2_3_max*Point)
        {SetLine(nmb+shift,ZZ2,T2,ZZ1,T1,Long,0,3);
         SetFibo("fb"+nmb+shift,ZZ2,T2,ZZ1,T1,Long,0,0);}
      }
      }
}
//--------------------------------------------------------
void Pattern0(int shift){
double zz=0,ZZ0=0,ZZ1=0,ZZ2=0,ZZ3=0,ZZ4=0; int cnt=0; 
int T0=0,T1=0,T2=0,T3=0,T4=0;
int bars=iBars(NULL,0);
for(int i=shift; i<Bars; i++){
    zz=0;
    zz=iCustom(NULL,0,"ZigZag", Depth,Deviation,Backstep,0,i);
    if(zz!=0 && cnt==0){ZZ0=zz; T0=Time[i]; cnt=1;continue;}
    if(cnt==1)if(zz!=0 && zz!=ZZ0){ZZ1=zz; T1=Time[i];  cnt=2; continue;}
    if(cnt==2)if(zz!=0 && zz!=ZZ1){ZZ2=zz; T2=Time[i];  cnt=3; continue;}
    if(cnt==3)if(zz!=0 && zz!=ZZ2){ZZ3=zz; T3=Time[i];  cnt=4; break;}
   }
   if(ZZ0<ZZ1){// DN
      if(ZZ1>ZZ2 && ZZ3>ZZ1)
      {
      if(ZZ1-ZZ2>=DistanseLimits_1_2_min*Point && ZZ1-ZZ2<=DistanseLimits_1_2_max*Point)
      if(ZZ3-ZZ2>=DistanseLimits_2_3_min*Point && ZZ3-ZZ2<=DistanseLimits_2_3_max*Point)
        {SetLine(nms+shift,ZZ2,T2,ZZ1,T1,Short,0,3);
         if(ZZ0<ZZ2)SetFibo("fb"+nms+shift,ZZ2,T2,ZZ1,T1,Short,0,0);}
      }
      }
   if(ZZ0>ZZ1){// UP
      if(ZZ1<ZZ2 && ZZ3<ZZ1)
      {
      if(ZZ2-ZZ1>=DistanseLimits_1_2_min*Point && ZZ2-ZZ1<=DistanseLimits_1_2_max*Point)
      if(ZZ2-ZZ3>=DistanseLimits_2_3_min*Point && ZZ2-ZZ3<=DistanseLimits_2_3_max*Point)
        {SetLine(nmb+shift,ZZ2,T2,ZZ1,T1,Long,0,3);
         if(ZZ0>ZZ2)SetFibo("fb"+nmb+shift,ZZ2,T2,ZZ1,T1,Long,0,0);}
      }
      }
return;
}
//------------------------------------------------------------------
//------------------------------------------------------------------
void SetLine(string name, double price1,int time1,double price2, int time2, color LineColor, int style,int width) {
  // if(ObjectFind(name)!= -1)ObjectDelete(name); 
   ObjectCreate(name,OBJ_TREND,0,0,0,0,0);
   ObjectSet(name,OBJPROP_STYLE,style);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectSet(name,OBJPROP_COLOR,LineColor);
   ObjectSet(name, OBJPROP_TIME1,   time1);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   ObjectSet(name, OBJPROP_TIME2,   time2);
   ObjectSet(name, OBJPROP_PRICE2, price2);
   ObjectSet(name,OBJPROP_RAY,false); 
}
//----------------------------------------------------------------------------
void SetFibo(string name,double pr1,int tm1,double pr2,int tm2,color col, int st, int wd){
double pr3,pr4;
if(col==Short){
  SetLine(name+"_1",pr2,tm1,pr2,tm2,Short,0,0);
  SetLine(name+"_2",pr1,tm1,pr1,tm2,Short,0,0);
  pr3=ND(pr2-(pr2-pr1)*1.618);
  pr4=ND(pr2-(pr2-pr1)*2.618);
  SetLine(name+"_3",pr3,tm1,pr3,tm2,Short,0,0);
  SetLine(name+"_4",pr4,tm1,pr4,tm2,Short,0,0);
  }
if(col==Long){
  SetLine(name+"_1",pr2,tm1,pr2,tm2,Long,0,0);
  SetLine(name+"_2",pr1,tm1,pr1,tm2,Long,0,0);
  pr3=ND(pr2+(pr1-pr2)*1.618);
  pr4=ND(pr2+(pr1-pr2)*2.618);
  SetLine(name+"_3",pr3,tm1,pr3,tm2,Long,0,0);
  SetLine(name+"_4",pr4,tm1,pr4,tm2,Long,0,0);
  }
}